//---------------------------------------------GEIGER dev_1_1---------------------------------------------------//
#include <stdio.h> 
#include <mega8.h>
#include <delay.h>
#define key1 PIND.0    
#define key2 PIND.1    
#define key3 PIND.2    
#define key4 PIND.3    
#define pulse PIND.4    
#define beep  PORTC.3
#define light  PORTC.2    
#define sound  PORTC.1
eeprom unsigned int zone1;    
eeprom unsigned int zone2;  
unsigned int k=0; //counted qants
int sec=0; //timer
int rf=0; //Ed rfon 
int j=0; // between fon
int i=1;  //buttons    < >
int m_buffer=0;  //buffert for k
int memory=1;     // FOR ZONE1
int memory1=2;     // FOR ZONE2
int warn=400;    // STANDART LEVEL
bit ok=0;       //OK
bit x=0;        //NO
bit a1=0;      //FOR MENU
bit a2=0;
bit a3=0;
bit a4=0;
char lcd_buffer[80]; //LCD BUFFER LEVEL!

//------------------------------------INTERRUPTS FOR SEC TIMER------------------------------------//
interrupt [TIM1_COMPA] void timer1_comp_isr(void)
{
sec++;
}
/*
void wait (void){
TCNT1=0;
while (TCNT1<780){};
}
*/

// Alphanumeric LCD Module functions
#asm
   .equ __lcd_port=0x18 ;PORTB
#endasm
#include <lcd.h>

// Declare your global variables here
//------------------------------------------Beep func--------------------------------
void my_beep(void) {    //key beep
        beep = 0;
        delay_ms(30);
        beep = 1;}//-------------------end beep--------------------------------------             
        /*/------------------------------------------Beep long--------------------------------
void long_beep(void) {    //key beep
        beep = 0;
        delay_ms(55);
        beep = 1;        
        delay_ms(30);
             beep = 0;
        delay_ms(30);
        beep = 1;} *///----------------------------end long beep-----------------------------
//---------------------------------------------KEYS FUNC------------------------------------
void my_keys(void){
if(!key1){ok=1;}else{delay_ms(10); ok=0;}
if(!key2){x=1;}else{delay_ms(10); x=0;}
if(i<8){if(!key4){i++; my_beep(); lcd_clear(); delay_ms(680); }}
if(i>1){if(!key3){i--; my_beep(); lcd_clear(); delay_ms(680); }}
}
//----------------------------------------------------MAIN PROGRAMM----------------------------------------//
void main(void)
{
PORTB=0x00;
DDRB=0x00;
PORTC=0x7F;
DDRC=0x7F;
PORTC.2=0;
PORTC.4=0;
PORTC.5=0;
PORTD=0xFF;
DDRD=0x00;
ACSR=0x80;
SFIOR=0x00;
//------------------------------------------FOR TIMER-----------------------------------------------//
OCR1A=4000;      // ---------------FOR QUARZ
TCCR1B=0x0D;
TIMSK=0x10;
//----------------------------------------------------------------------------------------------------//
lcd_init(16);
my_beep();   //--------------------START-----------------LOADS
delay_ms(100); 
my_beep();
/////////////////////////////-------------------------------------------------------------
while (1) {
my_keys();   //----------------------START----------------KEYS
 switch (i) { 
case 1: //---------------------------------------------------Start MENU----------------------------------------------------//    
my_keys(); 
lcd_gotoxy(0,0); lcd_putsf("Menu programm");
lcd_gotoxy(0,1); lcd_putsf("Enter key~      ");  
delay_ms(1); 
if(sec>=60){#asm("cli"); m_buffer=k; }  //anti kosac
break;   //STOP1
case 2: //----------------------------------------------------TEST MODE--------------------------------------------------//   
my_keys(); 
lcd_gotoxy(0,0); 
sprintf(lcd_buffer,"fon=%4umkr     Time=%2uc"  "RF=%2u ",k,sec,rf);//  PRINT ON LCD   
lcd_puts(lcd_buffer);  // FROM BUFFER TO LCD
delay_ms(1); // need wait on timers
if((ok)&(a1)){delay_ms(50);  #asm("sei");}  //Start  k=0; j=0; rf=0;
if(x){#asm("cli"); beep=1;}  //Stop
if(sec>=60){#asm("cli"); a1=0;m_buffer=k; }    // AUTO STOP
if(sec==61){sec=0; k=0; j=0; rf=0; beep=1;} //restart
if(ok){a1=1;}
if(x){a1=0;}
if((!pulse)&(a1)){delay_ms(10); k++; j++;}   // ENTER COUNTED QUANTS
if(j==20){delay_us(1); rf++; j=0;}   //  FOR ID RADIATION FON ID IS 15-25~=20;
if(k==warn){delay_us(1); beep=0;}   //ALARM radiation
if(k==1600){delay_us(1); sec=0; k=0; j=0; rf=0; beep=1;}   //max radiation
break;    
case 3: //--------------------------------------------EEPROM MEMORY LOAD/SAVE-------------ZONE1------------//
my_keys();
lcd_gotoxy(0,0); 
sprintf(lcd_buffer,"Zone1=%4umkr  ",memory);//   TO LCD
lcd_puts(lcd_buffer);
lcd_gotoxy(0,1); lcd_putsf("Save        Load");  
delay_ms(1); // need wait on timers
if(sec>=60){#asm("cli"); m_buffer=k; }  //anti kosac
if((ok)&(k>=10)){  zone1=m_buffer;} //save only quant>10  
if(x){  memory=zone1;}  //load
break;  
case 4: //--------------------------------------------EEPROM MEMORY LOAD/SAVE-------------ZONE2------------//
my_keys();
lcd_gotoxy(0,0); 
sprintf(lcd_buffer,"Zone2=%4umkr  ",memory1);//   
lcd_puts(lcd_buffer);
lcd_gotoxy(0,1); lcd_putsf("Save        Load");  
delay_ms(1); // need wait on timers
if(sec>=60){#asm("cli"); m_buffer=k; }  //anti kosac
if((ok)&(k>=10)){  zone2=k;} //save only quant>10  
if(x){  memory1=zone2;}  //load
break;  
case 5: //-------------------------------------BACKLIGHT ON/OFF----------------------------------------//  
my_keys();
lcd_gotoxy(0,0); lcd_putsf("Backlight  ");
lcd_gotoxy(0,1); lcd_putsf("v    on/off    x");               //green
if(ok){a2=1; PORTC.4=1;}    
if(x){a2=0; PORTC.4=0;}
delay_ms(1); 
if(sec>=60){#asm("cli"); m_buffer=k; }  //anti kosac
if(a2){   lcd_gotoxy(11,0); lcd_putsf("on   "); }   
if(!a2){  lcd_gotoxy(11,0); lcd_putsf("off  ");}    
break;      
case 6:  //-------------------------------------------SOUND REZONATOR  ON/OFF---------------------//
my_keys();
lcd_gotoxy(0,0); lcd_putsf("Sound      ");
lcd_gotoxy(0,1); lcd_putsf("v    on/off    x");               
if(ok){a3=1; PORTC.5=1;}    
if(x){a3=0; PORTC.5=0;}
delay_ms(1); 
if(sec>=60){#asm("cli"); m_buffer=k; }  //anti kosac
if(a3){   lcd_gotoxy(11,0); lcd_putsf("on   "); }   
if(!a3){  lcd_gotoxy(11,0); lcd_putsf("off  ");}    
break;      
case 7:  //---------------------------------WARNING LEVEL------------MODE +/- --------------------------// 
my_keys();
lcd_gotoxy(0,0); 
sprintf(lcd_buffer,"Warning=%4umkr  ",warn);//   
lcd_puts(lcd_buffer);
lcd_gotoxy(0,1); lcd_putsf("v      +/-     x");  
//delay_ms(1); // need wait on timers
if(sec>=60){#asm("cli"); m_buffer=k; }  //anti kosac
if(warn<1500){if(!key1){warn++; delay_ms(80); }}
if(warn>10){if(!key2){warn--;delay_ms(80); }}              
break;   
case 8: //-------------------------------------------------------------------------------------------//   
 my_keys(); 
lcd_gotoxy(0,0); 
sprintf(lcd_buffer,"Fon=%4umkr     Bufer=%4u"  "RF=%2u ",k,m_buffer=k,rf);//  PRINT ON LCD   
lcd_puts(lcd_buffer);
//lcd_gotoxy(0,1); lcd_putsf("While           ");  
delay_ms(1); // need wait on timers
if((ok)&(a4)){delay_ms(50);  #asm("sei");}  //Start  k=0; j=0; rf=0;
if(x){#asm("cli"); beep=1;}  //Stop
if(sec==61){ sec=0; k=0; j=0; rf=0; beep=1;m_buffer=k;} //restart   while
if(ok){a4=1;}
if(x){a4=0;}
if((!pulse)&(a4)){delay_ms(10); k++; j++;}      // quants
if(j==20){delay_us(1); rf++; j=0;}            //fon 20
if(k==warn){delay_us(1); beep=0;}   //ALARM radiation
if(k==1600){delay_us(1); sec=0; k=0; j=0; rf=0; beep=1;}   //max radiation
break;   



}
 };        
 }