/*****************************************************
CodeWizardAVR V1.24.4 Standard
Version : 1_0
Date    : 07.09.2008
Author  : Knazev I, S                                                                                                                                                                                                                                                                                                             
Comments:  GEIGER Gamma1 dev_1_1
Chip type           : ATmega8
Clock frequency     : 8,000000 MHz
*****************************************************/
// CodeVisionAVR C Compiler
// (C) 1998-2006 Pavel Haiduc, HP InfoTech S.R.L.

// Prototypes for standard I/O functions


// CodeVisionAVR C Compiler V2.0
// (C) 1998-2007 Pavel Haiduc, HP InfoTech S.R.L.

// Variable length argument list macros



typedef char *va_list;
typedef char *va_list;
typedef char *va_list;


 



#pragma used+

char getchar(void);
void putchar(char c);
void puts(char *str);
void putsf(char flash *str);

char *gets(char *str,unsigned int len);

void printf(char flash *fmtstr,...);
void sprintf(char *str, char flash *fmtstr,...);
void snprintf(char *str, unsigned int size, char flash *fmtstr,...);
void vprintf (char flash * fmtstr, va_list argptr);
void vsprintf (char *str, char flash * fmtstr, va_list argptr);
void vsnprintf (char *str, unsigned int size, char flash * fmtstr, va_list argptr);
signed char scanf(char flash *fmtstr,...);
signed char sscanf(char *str, char flash *fmtstr,...);




                                   

            


#pragma used-

#pragma library stdio.lib


// CodeVisionAVR C Compiler
// (C) 1998-2004 Pavel Haiduc, HP InfoTech S.R.L.

// I/O registers definitions for the ATmega8


#pragma used+
#pragma used+
sfrb TWBR=0;
sfrb TWSR=1;
sfrb TWAR=2;
sfrb TWDR=3;
sfrb ADCL=4;
sfrb ADCH=5;
sfrw ADCW=4;      // 16 bit access
sfrb ADCSRA=6;
sfrb ADMUX=7;
sfrb ACSR=8;
sfrb UBRRL=9;
sfrb UCSRB=0xa;
sfrb UCSRA=0xb;
sfrb UDR=0xc;
sfrb SPCR=0xd;
sfrb SPSR=0xe;
sfrb SPDR=0xf;
sfrb PIND=0x10;
sfrb DDRD=0x11;
sfrb PORTD=0x12;
sfrb PINC=0x13;
sfrb DDRC=0x14;
sfrb PORTC=0x15;
sfrb PINB=0x16;
sfrb DDRB=0x17;
sfrb PORTB=0x18;
sfrb EECR=0x1c;
sfrb EEDR=0x1d;
sfrb EEARL=0x1e;
sfrb EEARH=0x1f;
sfrw EEAR=0x1e;   // 16 bit access
sfrb UBRRH=0x20;
sfrb UCSRC=0X20;
sfrb WDTCR=0x21;
sfrb ASSR=0x22;
sfrb OCR2=0x23;
sfrb TCNT2=0x24;
sfrb TCCR2=0x25;
sfrb ICR1L=0x26;
sfrb ICR1H=0x27;
sfrw ICR1=0x26;   // 16 bit access
sfrb OCR1BL=0x28;
sfrb OCR1BH=0x29;
sfrw OCR1B=0x28;  // 16 bit access
sfrb OCR1AL=0x2a;
sfrb OCR1AH=0x2b;
sfrw OCR1A=0x2a;  // 16 bit access
sfrb TCNT1L=0x2c;
sfrb TCNT1H=0x2d;
sfrw TCNT1=0x2c;  // 16 bit access
sfrb TCCR1B=0x2e;
sfrb TCCR1A=0x2f;
sfrb SFIOR=0x30;
sfrb OSCCAL=0x31;
sfrb TCNT0=0x32;
sfrb TCCR0=0x33;
sfrb MCUCSR=0x34;
sfrb MCUCR=0x35;
sfrb TWCR=0x36;
sfrb SPMCR=0x37;
sfrb TIFR=0x38;
sfrb TIMSK=0x39;
sfrb GIFR=0x3a;
sfrb GICR=0x3b;
sfrb SPL=0x3d;
sfrb SPH=0x3e;
sfrb SREG=0x3f;
#pragma used-

// Interrupt vectors definitions


// Needed by the power management functions (sleep.h)
#asm
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif


// CodeVisionAVR C Compiler
// (C) 1998-2000 Pavel Haiduc, HP InfoTech S.R.L.


#pragma used+
#pragma used+

void delay_us(unsigned int n);
void delay_ms(unsigned int n);

#pragma used-

//KEY1 V 
//KEY2 <
//KEY3 >
//KEY4 X  
eeprom unsigned int zone1=1;    
eeprom unsigned int zone2=1;  
eeprom unsigned int load1=4;  
unsigned int k=0; //counted qants
int sec=0; //timer
int rf=0; //Ed rfon 
int j=0; // between fon
int i=1;  //buttons    < >
int m_buffer=0;  //buffert for k
int memory=1;     // FOR ZONE1
int memory1=2;     // FOR ZONE2
int warn=3;    // STANDART LEVEL  
bit ok=0;       //OK
bit x=0;        //NO
bit auto1=0;        //auto start mode
bit a1=0;      //start OFF
bit a2=0;    // BACKLIGHT OFF
//bit a3=0;    //SOUND REZONATOR  OFF
bit a4=0;    //AUTO RESTART MODE OFF
char lcd_buffer[125]; //LCD BUFFER LEVEL!
const unsigned char kirilTable[64]= {      //FOR RUSS TEXT
0x41, 0xA0, 0x42, 0xA1, 0xE0, 0x45, 0xA3, 0xA4, 0xA5, 0xA6, 0x4B, 0xA7, 0x4D, 0x48, 0x4F, 0xA8, 
0x50, 0x43, 0x54, 0xA9, 0xAA, 0x58, 0xE1, 0xAB, 0xAC, 0xE2, 0xAD, 0xAE, 0xAD, 0xAF, 0xB0, 0xB1, 
0x61, 0xB2, 0xB3, 0xB4, 0xE3, 0x65, 0xB6, 0xB7, 0xB8, 0xB9, 0xBA, 0xBB, 0xBC, 0xBD, 0x6F, 0xBE, 
0x70, 0x63, 0xBF, 0x79, 0xE4, 0x78, 0xE5, 0xC0, 0xC1, 0xE6, 0xC2, 0xC3, 0xC4, 0xC5, 0xC6, 0xC7};
//------------------------------------INTERRUPTS FOR SEC TIMER------------------------------------//
interrupt [7] void timer1_comp_isr(void)
{
sec++;
}
// External Interrupt 1 service routine  //PD3-pin #5
interrupt [3] void ext_int1_isr(void)
{
k++;  j++; 
if(j>20){ rf++; j=0;} 
if(rf==warn){ #asm("cli"); i=10; }    
}
//end external
// Alphanumeric LCD Module functions
#asm
   .equ __lcd_port=0x12 ;PORTD
/* LCD driver routines

  CodeVisionAVR C Compiler
  (C) 1998-2003 Pavel Haiduc, HP InfoTech S.R.L.

  BEFORE #include -ING THIS FILE YOU
  MUST DECLARE THE I/O ADDRESS OF THE
  DATA REGISTER OF THE PORT AT WHICH
  THE LCD IS CONNECTED!

  EXAMPLE FOR PORTB:

    #asm
        .equ __lcd_port=0x18
    #endasm
    #include <lcd.h>

*/


#pragma used+
#pragma used+

void _lcd_ready(void);
void _lcd_write_data(unsigned char data);
// write a byte to the LCD character generator or display RAM
void lcd_write_byte(unsigned char addr, unsigned char data);
// read a byte from the LCD character generator or display RAM
unsigned char lcd_read_byte(unsigned char addr);
// set the LCD display position  x=0..39 y=0..3
void lcd_gotoxy(unsigned char x, unsigned char y);
// clear the LCD
void lcd_clear(void);
void lcd_putchar(char c);
// write the string str located in SRAM to the LCD
void lcd_puts(char *str);
// write the string str located in FLASH to the LCD
void lcd_putsf(char flash *str);
// initialize the LCD controller
unsigned char lcd_init(unsigned char lcd_columns);

#pragma used-
#pragma library lcd.lib


//FOR RUSS TEXT
void dd_lcd(flash unsigned char *texti, unsigned char len ) 
{ unsigned char ii,P; 
for (ii=0;ii<len;ii++) { 
P= texti[ii]; 
if (P > 0x7F) P=kirilTable[texti[ii]-0xC0]; 
lcd_putchar(P); 
delay_ms(10); } 
}
//------------------------------------------Beep func--------------------------------
void my_beep(void) {    //key beep
        PORTC.5 = 1;
        delay_ms(30);
        PORTC.5 = 0;}//-------------------end beep--------------------------------------             
   //    ------------------------------------------Beep long--------------------------------
void long_beep(void) {    //key beep
        PORTC.5 = 1;
        delay_ms(105);
        PORTC.5 = 0;        
        delay_ms(100);
             PORTC.5 = 1;
        delay_ms(100);
        PORTC.5 = 0; 
        delay_ms(600);
        } //----------------------------Warn beep-----------------------------

//---------------------------------------------KEYS FUNC------------------------------------
void my_keys(void){
if(!PINB.1        ){ok=1;}else{delay_ms(10); ok=0;}    // ok
if(!PINB.3     ){x=1;}else{delay_ms(10); x=0;}     // x

if(i<8){ if(!PINB.4    ){i++; my_beep(); delay_ms(980); }}     // >
if(i>2){if(!PINB.2    ){i--; my_beep(); delay_ms(980);  }}   // <
}
//----------------------------------------------------MAIN PROGRAMM----------------------------------------//
void main(void)
{
warn=load1;     //AUTO load
PORTB=0xFF; //in
DDRB=0x00;
PORTC=0x4C;    //out
DDRC=0x33;
PORTD=0xFF;  //in
DDRD=0x00;

ACSR=0x80;
SFIOR=0x00;
//------------------------------------------FOR TIMER-----------------------------------------------//
OCR1A=4900;      // ---------------FOR QUARZ
TCCR1B=0x0D;
TIMSK=0x10;
//----------------------------------------------------------------------------------------------------//
// External Interrupt(s) initialization
// INT1: On
// INT1 Mode: is rising
GICR|=0x80;
MCUCR=0x0C;
GIFR=0x80;     //is int1 on/else off
//
lcd_init(16);
my_beep();   //--------------------START-----------------LOADS


//-------------------------------------------------------screen seer
lcd_gotoxy(0,0); lcd_putsf("  Gamma1 V_1.1  ");
lcd_gotoxy(0,1); dd_lcd("   <1>    ",16); 
delay_ms(4950);

lcd_clear();
///------------------------------------------------------------
while (1) {
my_keys();   //----------------------START----------------KEYS
 switch (i) { 
case 1: //---------------------------------------------------Start MENU----------------------------------------------------//
#asm("cli"); 
     
PORTC.5=0;
//m_buffer=k;
k=0;
j=0;
sec=0; //timer
rf=0; 
PORTC.0=1; //start bloking generator

lcd_gotoxy(0,0); dd_lcd("  1 ",16); 
lcd_gotoxy(0,1); dd_lcd("  v...   ",16); 
if((!PINB.1        )|(!PINB.4    )|(!PINB.2    )|(!PINB.3     )){my_beep();delay_ms(900);  i++;}// any key press 
break;   //STOP1
case 2: //----------------------------------------------MAIN TEST/AUTO MODE--------------------------------------------------//   
my_keys(); 
lcd_gotoxy(3,0); 
sprintf(lcd_buffer,"=%4umkp " "T%2uc"  "Rf=%2u " "Bufer%4u ",k,sec,rf,m_buffer);//  PRINT ON LCD   
lcd_puts(lcd_buffer);  // FROM BUFFER TO LCD
lcd_gotoxy(0,0); dd_lcd("",3); 
//lcd_gotoxy(7,1); dd_lcd("",5);

if((ok)&(a1)){delay_ms(100);  #asm("sei"); PORTC.0=1; }  //Start 
if(x){#asm("cli");  PORTC.5=0; PORTC.0=0; }  //Stop
if(sec>=60){m_buffer=k; #asm("cli"); a1=0; } // AUTO STOP
if(sec==61){sec=0; k=0; j=0; rf=0; } //restart
if((sec==60)&(auto1)){sec=0; k=0; j=0; rf=0; #asm("sei"); a1=1;} //auto restart mode:2
if((sec==59)&(!auto1)){delay_ms(350); long_beep();} //only test beep
if(ok){a1=1;}
if(x){a1=0;}

if(k==1600){delay_us(1); sec=0; k=0; j=0; rf=0; PORTC.5=0;}   //max radiation
//if(b){long_beep(); delay_us(1); beep=1; b=0;} // restart long beep
break;   
case 3:  //-------------------------------------------AUTO RESTART MODE---------------------//
my_keys();
lcd_gotoxy(0,0); dd_lcd("",5); 
lcd_gotoxy(0,1); dd_lcd(" 1-  2- ",16);               
if(ok){a4=0; auto1=0; }    
if(x){a4=1; auto1=1; }

if(sec>=60){#asm("cli"); m_buffer=k; }  //anti kosac
//lcd_gotoxy(7,0); lcd_putsf("          ");
if(a4){   lcd_gotoxy(5,0); lcd_putsf("2          ");}   
if(!a4){  lcd_gotoxy(5,0); lcd_putsf("1          ");}  

break;   
case 4: //--------------------------------------------EEPROM MEMORY LOAD/SAVE-------------ZONE1------------//
my_keys();
lcd_gotoxy(4,0); 
sprintf(lcd_buffer,"1=%4umkp   ",memory);//   TO LCD
lcd_puts(lcd_buffer);
lcd_gotoxy(0,0); dd_lcd("" ,4);  
lcd_gotoxy(0,1); dd_lcd(" <> " ,16);  
//delay_ms(1); // need wait on timers
if(sec>=60){#asm("cli"); m_buffer=k; }  //anti kosac
if((ok)&(k>=5)){  zone1=m_buffer; my_beep(); delay_ms(900);} //save only quant>10  
if(x){  memory=zone1;my_beep(); delay_ms(900);}  //load

break;  
case 5: //--------------------------------------------EEPROM MEMORY LOAD/SAVE-------------ZONE2------------//
my_keys();
lcd_gotoxy(4,0); 
sprintf(lcd_buffer,"2=%4umkp   ",memory1);//   
lcd_puts(lcd_buffer);
lcd_gotoxy(0,0); dd_lcd("" ,4);  
lcd_gotoxy(0,1); dd_lcd(" <> " ,16);  
//delay_ms(1); // need wait on timers
if(sec>=60){#asm("cli"); m_buffer=k; }  //anti kosac
if((ok)&(k>=5)){  zone2=k; my_beep(); delay_ms(900);} //save only quant>10  
if(x){  memory1=zone2; my_beep(); delay_ms(900);}  //load

break;  
case 6: //-------------------------------------BACKLIGHT ON/OFF----------------------------------------//  
my_keys();
lcd_gotoxy(0,0); dd_lcd("  " ,11);  
lcd_gotoxy(0,1); dd_lcd("v  </>  x" ,16);             
if(ok){a2=1; PORTC.4=1;}    
if(x){a2=0; PORTC.4=0;}
//delay_ms(1); 
if(sec>=60){#asm("cli"); m_buffer=k; }  //anti kosac
if(a2){   lcd_gotoxy(11,0); dd_lcd("  ",5); }   
if(!a2){  lcd_gotoxy(11,0); dd_lcd(" ",5);}    

break;      
//case 7:  //-------------------------------------------SOUND REZONATOR  ON/OFF---------------------//
//my_keys();
//lcd_gotoxy(0,0); dd_lcd("       " ,11);  
//lcd_gotoxy(0,1); dd_lcd("v   /   x" ,16);            
//if(ok){a3=1; PORTC.1=1;}    
//if(x){a3=0; PORTC.1=0;}
//delay_ms(1); 
//if(sec>=60){#asm("cli"); m_buffer=k; }  //anti kosac
//if(a3){   lcd_gotoxy(11,0); dd_lcd("  ",5); }   
//if(!a3){  lcd_gotoxy(11,0); dd_lcd(" ",5);}    

//if(j==20){delay_us(1); rf++; j=0;}   //  FOR ID RADIATION FON ID IS 15-25~=20;
//if(k>warn){delay_us(1); #asm("cli"); i=11; }   //to ALARM radiation
//break;      
case 7:  //---------------------------------WARNING LEVEL------------MODE +/- --------------------------// 
my_keys();
lcd_gotoxy(7,0); 
sprintf(lcd_buffer,"=%3u ",warn);//   
lcd_puts(lcd_buffer);
lcd_gotoxy(0,0); 
dd_lcd("",7);    
lcd_gotoxy(0,1); dd_lcd("+ <   > -",16);    
lcd_gotoxy(12,0); dd_lcd(" ",4);    
if(sec>=60){#asm("cli"); m_buffer=k; }  //anti kosac
if(warn<400){if(!PINB.1        ){warn++;   load1=warn; delay_ms(380);   }}
if(warn>2){if(!PINB.3     ){warn--;  load1=warn;  delay_ms(380);  }}  

break;
case 8:  //-------------------POWER--DOWN--MODE --------------------------// 
//#asm("cli");
my_keys();
sec=0; //for 1 main menu
lcd_gotoxy(0,0); dd_lcd("     ",16);   
lcd_gotoxy(0,1); dd_lcd("    <<   ",16);  
if(!PINB.1        ){delay_ms(90); my_beep(); rf=0; j=0;    i=9;}// go to case9

break;
case 9:  //-------------------POWER--DOWN--ON--------------------------//
#asm("cli"); 
lcd_clear(); 
auto1=0;        //auto off
a1=0;      //start OFF
a2=0;    // BACKLIGHT OFF
//a3=0;    //SOUND REZONATOR  OFF
a4=0;    //AUTO RESTART MODE OFF
//sound=0;   //off
PORTC.4    =0;     //off
#asm("sei");  //Start 
if(!PINB.3     ){#asm("cli"); k=0; j=0; PORTC.5=0; sec=0; rf=0; i=8;}  //Stop   mode end EXIT
if(sec==60){sec=0; k=0; j=0; rf=0; } //auto restart mode:2

if((sec==5)|(sec==15)|(sec==25)|(sec==35)|(sec==45)|(sec==55)){ PORTC.0=0;}// off bloking
if((sec==0)|(sec==10)|(sec==20)|(sec==30)|(sec==40)|(sec==50)|(sec==59)){ PORTC.0=1;}//on bloking
// to lcd markers  (is scan)
if((sec==10)|(sec==20)|(sec==30)|(sec==40)|(sec==50)|(sec==59)){
delay_ms(160);   
lcd_gotoxy(0,0); lcd_putsf("");
lcd_gotoxy(0,1); dd_lcd("....",16);    
delay_ms(160);  
lcd_gotoxy(1,0); lcd_putsf(""); 
delay_ms(160);  
lcd_gotoxy(2,0); lcd_putsf(""); 
delay_ms(160);  
lcd_gotoxy(3,0); lcd_putsf(""); 
delay_ms(160);  
lcd_gotoxy(4,0); lcd_putsf(""); 
delay_ms(160);  
lcd_gotoxy(5,0); lcd_putsf(""); 
delay_ms(160);  
lcd_gotoxy(6,0); lcd_putsf(""); 
delay_ms(160);  
lcd_gotoxy(7,0); lcd_putsf(""); 
delay_ms(160);  
lcd_gotoxy(8,0); lcd_putsf(""); 
delay_ms(160);  
lcd_gotoxy(9,0); lcd_putsf(""); 
delay_ms(160);  
lcd_gotoxy(10,0); lcd_putsf(""); 
delay_ms(160);  
lcd_gotoxy(11,0); lcd_putsf(""); 
delay_ms(160);  
lcd_gotoxy(12,0); lcd_putsf(""); 
delay_ms(160);  
lcd_gotoxy(13,0); lcd_putsf(""); 
delay_ms(160);  
lcd_gotoxy(14,0); lcd_putsf(""); 
delay_ms(160);}  
break;
case 10:  //-------------------Alarm case --------------------------// 
//my_keys();
sec=0; //for 1 main menu
PORTC.5=1; 
lcd_gotoxy(0,0); dd_lcd("  ",16);   
lcd_gotoxy(0,1); dd_lcd("!      ",16);  
if((!PINB.1        )|(!PINB.4    )|(!PINB.2    )|(!PINB.3     )){delay_ms(90); my_beep(); PORTC.5=0; i=1;}// go to case1
delay_ms(200);
PORTC.5=0;
break;

}
 };        
 }
